 /*
  GIOCO PROVA RIFLESSI CON ARDUINO NANO

  Questo progetto è di libero utilizzo, basta che venga citato il programmatore.
  Programmatore Firmware: Tartaglia daniele
  sito: www.labdomotic.com
  email: edstarink@fastwebnet.it
  Youtube channel: https://www.youtube.com/channel/UCwMjr5HocO6S363x_-jzsmA
  Facebook: https://www.facebook.com/daniele.tartaglia.73?ref=bookmarks
*/


#include <Wire.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27, 16, 2); // set the LCD address to 0x27 for a 16 chars and 2 line display

// ATTENZIONEEEEEEEEEEEEEEEEEE  se avete problemi nel visualizzare i caratteri SUL DISPLAY 
// al posto di "" LiquidCrystal_I2C lcd(0x3F, 16, 2); "" scrivete  ""LiquidCrystal_I2C lcd(0x3F, 16, 2);


// COSTANTI MODIFICABILI PER PARAMETRI GIOCO

int PUNTEGGIOstep = 150; // Assegna il punteggio per pressione corretta/errata
int TEMPOpenalita = 1000; // Assegna il tempo in secondi per la penalità pressione errata
int TEMPOrilancio = 100; // Assegna il tempo di rilancio a pressione corretta
int TIMERgiocoCOUNTdown = 50; // Assegna il tempo per il contatore COUNTDOWN durante il gioco (Minore valore, velocità maggiore)
int PunteggioRecord = 1500; // Imposta il punteggio record iniziale
int velocitaBarra = 10; //  Inserire la velocità del tempo


const int pin_PULSANTE_START = 10;
int RANDOM = 0;
int FLAGgioco = 0;



int qualeLAMPADAaccesa = 1;
int FLAGtime = 0;
int previousRandomInt = 0;
int randomInt = 0;
int tempoLampeggio = 0;

// ASSEGNA PULSANTI COLORATI
const int pin_pulsanteGIALLO = 6;
const int pin_pulsanteBLU = 7;
const int pin_pulsanteVERDE = 8;
const int pin_pulsanteROSSO = 9;

// ASSEGNA PIN RELè O LAMPADE
int PIN_relayGIALLO = 2;
int PIN_relayBLU = 3;
int PIN_relayVERDE = 4;
int PIN_relayROSSO = 5;

int DEMOEFFECT = 0;
int DEMOTIME = 0;
int STEP_DEMO = 1;

unsigned long time;
unsigned long timeCASUALE;
unsigned long lampeggio_time = 0;
unsigned long lampeggio_timeCASUALE = 0;


int buttonState = 0;
int buttonStateROSSO = 0;
int buttonStateVERDE = 0;
int buttonStateBLU = 0;
int buttonStateGIALLO = 0;

// CUSTOM CARACTER PER BIG DISPLAY
uint8_t uno[8] = {0x07, 0x0F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F,};
uint8_t due[8] = {0x1F, 0x1F, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00,};
uint8_t tre[8] = {0x1C, 0x1E, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F,};
uint8_t quattro[8] = {0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x0F, 0x07,};
uint8_t cinque[8] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x1F, 0x1F,};
uint8_t sei[8] = {0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1E, 0x1C,};
uint8_t sette[8] = {0x1F, 0x1F, 0x1F, 0x00, 0x00, 0x00, 0x1F, 0x1F,};
uint8_t otto[8] = {0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F,};

int StepFunzione = 0;
int TempoBarra = 0;
int kecerahan = 0;
int progressBari = 0;
int punteggioReale = 0;
int i = 0;

int punteggioMax = 0;
int punteggioGioco = 1000;



/*
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX      VOID SETUP   XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX      VOID SETUP   XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
*/

void setup()
{


  Serial.begin(9600);
  // CONFIGURAZIONE PULSANTI / USCITE
  pinMode(pin_PULSANTE_START, INPUT_PULLUP);

  pinMode(pin_pulsanteGIALLO, INPUT_PULLUP);
  pinMode(pin_pulsanteBLU, INPUT_PULLUP);
  pinMode(pin_pulsanteVERDE, INPUT_PULLUP);
  pinMode(pin_pulsanteROSSO, INPUT_PULLUP);

  pinMode(PIN_relayGIALLO, OUTPUT);
  pinMode(PIN_relayBLU, OUTPUT);
  pinMode(PIN_relayVERDE, OUTPUT);
  pinMode(PIN_relayROSSO, OUTPUT);


  // FORZA I PIN OUT DEI RELè A LOW

  digitalWrite( PIN_relayGIALLO, HIGH );
  digitalWrite( PIN_relayBLU, HIGH );
  digitalWrite( PIN_relayVERDE, HIGH );
  digitalWrite( PIN_relayROSSO, HIGH );


  lcd.begin();
  lcd.createChar(0, uno); // Sends the custom char to lcd
  lcd.createChar(1, due); // Sends the custom char to lcd
  lcd.createChar(2, tre); // Sends the custom char to lcd
  lcd.createChar(3, quattro); // Sends the custom char to lcd
  lcd.createChar(4, cinque); // Sends the custom char to lcd
  lcd.createChar(5, sei); // Sends the custom char to lcd
  lcd.createChar(6, sette); // Sends the custom char to lcd
  lcd.createChar(7, otto); // Sends the custom char to lcd


  // INTRODUZIONE SCRITTE
  lcd.setCursor(0, 0);
  lcd.print ("Gioco riflessi");
  lcd.setCursor(0, 1);
  lcd.print ("T.D channel");
  delay (2000);
  lcd.setCursor(0, 0);
  lcd.print ("Vers. Beatrice ");
  lcd.setCursor(0, 1);
  lcd.print ("Firm 0.1b     ");
  delay (2000);


}

void custom0()
{ // uses segments to build the number 0
  lcd.setCursor(0, 0); // set cursor to column 0, line 0 (first row)
  lcd.write(0);  // call each segment to create
  lcd.write(1);  // top half of the number
  lcd.write(2);
  lcd.setCursor(0, 1); // set cursor to colum 0, line 1 (second row)
  lcd.write(3);  // call each segment to create
  lcd.write(4);  // bottom half of the number
  lcd.write(5);
}

void custom1()
{
  lcd.setCursor(0, 0);
  lcd.write(1);
  lcd.write(2);
  lcd.setCursor(0, 1);
  lcd.write(4);
  lcd.write(7);
  lcd.write(4);
}

void custom2()
{
  lcd.setCursor(0, 0);
  lcd.write(6);
  lcd.write(6);
  lcd.write(2);
  lcd.setCursor(0, 1);
  lcd.write(3);
  lcd.write(4);
  lcd.write(4);
}

void custom3()
{
  lcd.setCursor(0, 0);
  lcd.write(6);
  lcd.write(6);
  lcd.write(2);
  lcd.setCursor(0, 1);
  lcd.write(4);
  lcd.write(4);
  lcd.write(5);
}

void custom4()
{
  lcd.setCursor(0, 0);
  lcd.write(3);
  lcd.write(4);
  lcd.write(7);
  lcd.setCursor(2, 1);
  lcd.write(7);
}

void custom5()
{
  lcd.setCursor(0, 0);
  lcd.write(3);
  lcd.write(6);
  lcd.write(6);
  lcd.setCursor(0, 1);
  lcd.write(4);
  lcd.write(4);
  lcd.write(5);
}

void custom6()
{
  lcd.setCursor(0, 0);
  lcd.write(0);
  lcd.write(6);
  lcd.write(6);
  lcd.setCursor(0, 1);
  lcd.write(3);
  lcd.write(4);
  lcd.write(5);
}

void custom7()
{
  lcd.setCursor(0, 0);
  lcd.write(1);
  lcd.write(1);
  lcd.write(2);
  lcd.setCursor(2, 1);
  lcd.write(7);
}

void custom8()
{
  lcd.setCursor(0, 0);
  lcd.write(0);
  lcd.write(6);
  lcd.write(2);
  lcd.setCursor(0, 1);
  lcd.write(3);
  lcd.write(4);
  lcd.write(5);
}

void custom9()
{
  lcd.setCursor(0, 0);
  lcd.write(0);
  lcd.write(6);
  lcd.write(2);
  lcd.setCursor(2, 1);
  lcd.write(7);
}

void clearnumber()
{ // clears the area the custom number is displayed in
  lcd.setCursor(0, 0);
  lcd.print("   ");
  lcd.setCursor(0, 1);
  lcd.print("   ");
}


/*
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX      VOID LOOP   XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX      VOID LOOP   XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
*/


void loop() {

  //  STRUTTURA DEL PROGRAMMA

  switch (StepFunzione) {
    case 0:    // your hand is on the sensor
      DEMO_INIZIALE();
      break;
    case 1:    // your hand is close to the sensor
      COUNTDOWN();
      break;
    case 2:    // your hand is a few inches from the sensor
      GAMEPLAY();
      break;
    case 3:    // your hand is nowhere near the sensor
      FINE_GIOCO();
      break;
  }
  delay(1);        // delay in between reads for stability
}


/*
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX      DEMO INIZIALE  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX      DEMO INIZIALE  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
*/

void DEMO_INIZIALE() {

  progressBari = 0;
  punteggioReale = 0;
  lcd.setCursor (0, 1);
  lcd.print("Max score: ");
  lcd.print(PunteggioRecord);


  //  lampeggio start    ----------------------
  time = millis();
  if (time > lampeggio_time + 500)
  {
    lcd.setCursor (2, 0);
    lcd.print("Press start");
  }
  if (time > lampeggio_time + 1000)
  {
    lcd.setCursor(0, 0);
    lcd.print("                ");
    lampeggio_time = millis();
  }

  //  EFFETTO DEMO (Possibile espansione usando altri "case"

  switch (DEMOEFFECT) {
    case 0:    // your hand is on the sensor
      delay (300);
      DEMOTIME++;
      if (DEMOTIME == 1)digitalWrite(PIN_relayGIALLO, LOW);
      if (DEMOTIME == 2)digitalWrite(PIN_relayBLU, LOW);
      if (DEMOTIME == 3)digitalWrite(PIN_relayVERDE, LOW);
      if (DEMOTIME == 4)digitalWrite(PIN_relayROSSO, LOW);
      if (DEMOTIME == 5)digitalWrite(PIN_relayGIALLO, HIGH);
      if (DEMOTIME == 6)digitalWrite(PIN_relayBLU, HIGH);
      if (DEMOTIME == 7)digitalWrite(PIN_relayVERDE, HIGH);
      if (DEMOTIME == 8)digitalWrite(PIN_relayROSSO, HIGH);
      if (DEMOTIME >= 8)
        DEMOTIME = 0;

      if (STEP_DEMO > 3) DEMOTIME = 1;

      break;
      delay (300);
      DEMOTIME++;
      if (DEMOTIME == 1) {
        digitalWrite(PIN_relayGIALLO, LOW);
        digitalWrite(PIN_relayROSSO, LOW);
      }
      if (DEMOTIME == 2)digitalWrite(PIN_relayBLU, LOW);
      if (DEMOTIME == 3)digitalWrite(PIN_relayVERDE, LOW);
      if (DEMOTIME == 4)digitalWrite(PIN_relayROSSO, LOW);
      if (DEMOTIME == 5)digitalWrite(PIN_relayGIALLO, HIGH);
      if (DEMOTIME == 6)digitalWrite(PIN_relayBLU, HIGH);
      if (DEMOTIME == 7)digitalWrite(PIN_relayVERDE, HIGH);
      if (DEMOTIME == 8)digitalWrite(PIN_relayROSSO, HIGH);
      if (DEMOTIME >= 8)
        DEMOTIME = 0;

      if (STEP_DEMO > 3) DEMOTIME = 1;
      break;
    case 2:    // your hand is a few inches from the sensor
      Serial.println("medium");
      break;
    case 3:    // your hand is nowhere near the sensor
      Serial.println("bright");
      break;
  }


  //  ALLA PRESSIONE DEL TASTO START, VAI ALLA FUNZIONE: COUNTDOWN()

  buttonState = digitalRead(pin_PULSANTE_START);
  if (buttonState == LOW) {
    lcd.clear();
    delay(500);
    StepFunzione = 1;
    lcd.clear();


  }



}


/*
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX      CONUT DOWN     XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX      CONUT DOWN     XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
*/


void COUNTDOWN()
{
  //SPEGNI TUTTI RELE
  if (DEMOTIME == 5)digitalWrite(PIN_relayGIALLO, HIGH);
  if (DEMOTIME == 5)digitalWrite(PIN_relayBLU, HIGH);
  if (DEMOTIME == 5)digitalWrite(PIN_relayVERDE, HIGH);
  if (DEMOTIME == 5)digitalWrite(PIN_relayROSSO, HIGH);


  // CONTATORE AL' INDIETRO CON BIG DISPALY

  lcd.setCursor(5, 0);
  lcd.print("Inizio tra:");
  lcd.setCursor(9, 1);

  clearnumber();
  custom4();
  delay(500);
  clearnumber();
  custom3();
  delay(500);
  clearnumber();
  custom2();
  delay(500);
  clearnumber();
  custom1();
  delay(500);
  clearnumber();
  custom0();
  delay(500);
  clearnumber();


  lcd.clear();
  delay(200);
  
  //SPEGNI TUTTI RELE
  if (DEMOTIME == 5)digitalWrite(PIN_relayGIALLO, HIGH);
  if (DEMOTIME == 5)digitalWrite(PIN_relayBLU, HIGH);
  if (DEMOTIME == 5)digitalWrite(PIN_relayVERDE, HIGH);
  if (DEMOTIME == 5)digitalWrite(PIN_relayROSSO, HIGH);
  StepFunzione = 2;
}




//----------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------       GAME PLAY            --------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------



void GAMEPLAY () {


  lcd.setCursor (0, 0);
  lcd.print("punteggio: ");
  lcd.print(punteggioReale);

  lcd.setCursor(0, 1);
  kecerahan = map(TempoBarra, 0, 1024, 0, 255);

  progressBari = map(kecerahan, 0, 255, 0, 17);
  for (i = 0; i < progressBari; i++)
  {
    lcd.setCursor(i, 1);
    lcd.write(byte(0));
  }



  //  TEMPORIZZATORE PROGRESSIVO CON MILLIS (PER EVITARE DELAY)

  time = millis();
  if (time > lampeggio_time + TIMERgiocoCOUNTdown)
  {
    TempoBarra = TempoBarra + velocitaBarra;
    lampeggio_time = millis();
  }



  //  PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO
  //  PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO
  //  PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO
  //  PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO   PUNTEGGIO  PUNTEGGIO



  // ASSEGNA NUMERO CASUALE UNA VOLTA SOLA ATTRAVERSO UN FLAG CHE INTERROMPE IMMEDIATAMENTE

  if (FLAGtime == 0) {
    randomInt = random(1, 5);
    FLAGtime = 1;
  }


  // ACCENDI RELè
  if (randomInt == 1)digitalWrite(PIN_relayGIALLO, LOW);
  if (randomInt == 2)digitalWrite(PIN_relayBLU, LOW);
  if (randomInt == 3)digitalWrite(PIN_relayVERDE, LOW);
  if (randomInt == 4)digitalWrite(PIN_relayROSSO, LOW);



  ///////    PULSANTE ROSSO ------------------PULSANTE ROSSO ------------------

  buttonStateROSSO = digitalRead(pin_pulsanteROSSO);
  if (buttonStateROSSO == LOW)
  {
    if (randomInt == 4)
    {
      punteggioReale = punteggioReale + PUNTEGGIOstep;
      FLAGgioco = 1;
    }

  }

  if (buttonStateROSSO == LOW)
  {
    if (randomInt != 4)

    {
      punteggioReale = punteggioReale - PUNTEGGIOstep;
      FLAGgioco = 2;
    }

  }

  ///////    PULSANTE VERDEEE ------------------PULSANTE VERDEEE ------------------


  buttonStateVERDE = digitalRead(pin_pulsanteVERDE);
  if (buttonStateVERDE == LOW)
  {

    if (randomInt == 3)

    {
      punteggioReale = punteggioReale + PUNTEGGIOstep;
      FLAGgioco = 1;
    }

  }

  if (buttonStateVERDE == LOW)
  {
    if (randomInt != 3)

    {
      punteggioReale = punteggioReale - PUNTEGGIOstep;
      FLAGgioco = 2;
    }

  }

  ///////    PULSANTE BLUUUU ------------------PULSANTE BLUUUU------------------

  buttonStateBLU = digitalRead(pin_pulsanteBLU);
  if (buttonStateBLU == LOW)
  {

    if (randomInt == 2)

    {
      punteggioReale = punteggioReale + PUNTEGGIOstep;
      FLAGgioco = 1;
    }

  }

  if (buttonStateBLU == LOW)
  {
    if (randomInt != 2)

    {
      punteggioReale = punteggioReale - PUNTEGGIOstep;
      FLAGgioco = 2;
    }

  }

  // porta a zero il valore se ha valori negativi
  if (punteggioReale < 0)
    punteggioReale = 0;

  ///////    PULSANTE GIALLO ------------------PULSANTE GIALLO------------------

  buttonStateGIALLO = digitalRead(pin_pulsanteGIALLO);
  if (buttonStateGIALLO == LOW)
  {

    if (randomInt == 1)

    {
      punteggioReale = punteggioReale + PUNTEGGIOstep;
      FLAGgioco = 1;
    }

  }

  if (buttonStateGIALLO == LOW)
  {
    if (randomInt != 1)

    {
      punteggioReale = punteggioReale - PUNTEGGIOstep;
      FLAGgioco = 2;
    }

  }




  // RESETTA LA FLAG  --- PRESSIONE CORRETTA
 
  if (FLAGgioco == 1) {
    delay(TEMPOrilancio);
    lcd.setCursor (9, 0);
    lcd.print("       ");
    FLAGgioco = 0;
    FLAGtime = 0;
    digitalWrite(PIN_relayGIALLO, HIGH);
    digitalWrite(PIN_relayBLU, HIGH);
    digitalWrite(PIN_relayVERDE, HIGH);
    digitalWrite(PIN_relayROSSO, HIGH);
  }


  // RESETTA LA FLAG ---  PPRESSIONE ERRATA
 
  if (FLAGgioco == 2) {
    digitalWrite(PIN_relayGIALLO, LOW);
    digitalWrite(PIN_relayBLU, LOW);
    digitalWrite(PIN_relayVERDE, LOW);
    digitalWrite(PIN_relayROSSO, LOW);
    delay(TEMPOpenalita);
    lcd.setCursor (9, 0);
    lcd.print("       ");
    FLAGgioco = 0;
    FLAGtime = 0;
    digitalWrite(PIN_relayGIALLO, HIGH);
    digitalWrite(PIN_relayBLU, HIGH);
    digitalWrite(PIN_relayVERDE, HIGH);
    digitalWrite(PIN_relayROSSO, HIGH);
  }






  // TEMPO GIOCO FINITO...VAI A GAME OVER
  if (progressBari > 16) {
    lcd.clear();
    delay(1000);
    TempoBarra = 0;
    digitalWrite(PIN_relayGIALLO, LOW);
    digitalWrite(PIN_relayBLU, LOW);
    digitalWrite(PIN_relayVERDE, LOW);
    digitalWrite(PIN_relayROSSO, LOW);
    delay(200);
    digitalWrite(PIN_relayGIALLO, HIGH);
    delay(200);
    digitalWrite(PIN_relayROSSO, HIGH);
    delay(200);
    digitalWrite(PIN_relayBLU, HIGH);
    delay(200);
    digitalWrite(PIN_relayVERDE, HIGH);

    // ASSEGNA ALLA VARIABILE PUNTEGGIO RECORD, IL PUNTEGGIO RAGGIUNTO SE MAGGIORE
    if (punteggioReale >= PunteggioRecord)
      PunteggioRecord = punteggioReale;
    StepFunzione = 3;

  }
}


/*
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX     FINE GIOCO      XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX     FINE GIOCO      XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
*/


void FINE_GIOCO() {
  if  (punteggioReale >= PunteggioRecord) {

    lcd.setCursor (0, 0);
    lcd.print ("NewRecord: ");
    lcd.print (punteggioReale);
    lcd.setCursor (0, 1);
    lcd.print ("   Finegioco   ");
    delay (300);
    lcd.clear();
    delay (300);
    tempoLampeggio++;
  }


  if  (punteggioReale < PunteggioRecord) {
    lcd.setCursor (0, 0);
    lcd.print ("score: ");
    lcd.print (punteggioReale);
    lcd.setCursor (0, 1);
    lcd.print ("   Finegioco   ");
    delay (4300);
    StepFunzione = 0;

  }

  if (tempoLampeggio > 6) {
    tempoLampeggio = 0;
    StepFunzione = 0;
  }



  digitalWrite(PIN_relayGIALLO, HIGH);
  digitalWrite(PIN_relayBLU, HIGH);
  digitalWrite(PIN_relayVERDE, HIGH);
  digitalWrite(PIN_relayROSSO, HIGH);


}

